require 'set'

class Books
  def initialize
    @books = []
  end

  def add(book)
    @books.append(book)
    @books.sort_by! do |book|
      book.author + book.name
    end
  end

  def each(&block)
    @books.each(&block)
  end

  def books_by_genre(genre)
    @books.select do |book|
      book.genre == genre
    end
  end

  def genres
    Set.new(@books.map(&:genre)).to_a
  end

  def by_number(number)
    @books[number]
  end
end
